#include "imageaes.h"

LPCSTR szWindowClass = "A_WND_CLASS";
LPCSTR szWindowTitle = "摜AES Ver1.00";
password_t password;
HINSTANCE hInst;

void wndresizebyclient(HWND hWnd,int x,int y) {
	RECT size;
	RECT wndsize;
	GetClientRect(hWnd,&size);
	GetWindowRect(hWnd,&wndsize);
	wndsize.right=wndsize.right-wndsize.left;
	wndsize.bottom=wndsize.bottom-wndsize.top;
	SetWindowPos(hWnd,NULL,0,0,x+wndsize.right-size.right,wndsize.bottom,SWP_NOMOVE | SWP_NOREPOSITION | SWP_NOZORDER);
	GetClientRect(hWnd,&size);
	GetWindowRect(hWnd,&wndsize);
	wndsize.right=wndsize.right-wndsize.left;
	wndsize.bottom=wndsize.bottom-wndsize.top;
	SetWindowPos(hWnd,NULL,0,0,wndsize.right,y+wndsize.bottom-size.bottom,SWP_NOMOVE | SWP_NOREPOSITION | SWP_NOZORDER);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message,
                         WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc;
	HBITMAP htempbmp;
	bmp_t* tempbmp;
	static HDC hbmpdc;
	static HBITMAP holdbmp;
	static HBITMAP hcurrentbmp;
	static bmp_t* currentbmp=NULL;
	static bmp_t* hirabmp=NULL;

	switch (message) {
		case WM_CREATE:
			hdc=GetDC(hWnd);
			hbmpdc=CreateCompatibleDC(hdc);
			currentbmp=bmpMake(640,480);
			{
				int i,j;
				for(i=0;i<640;i++) {
					for(j=0;j<480;j++) {
						getBmpXY(currentbmp,i,j).r=255;
						getBmpXY(currentbmp,i,j).g=255;
						getBmpXY(currentbmp,i,j).b=255;
					}
				}
			}
			hcurrentbmp=bmpSaveToHandle(hdc,currentbmp);
			holdbmp=SelectObject(hbmpdc,hcurrentbmp);
			ReleaseDC(hWnd,hdc);
			wndresizebyclient(hWnd,
				getBmpWidth(currentbmp),getBmpHeight(currentbmp));
			SetMenuEnable(hWnd,FALSE);
			break;
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDM_OPEN:
					tempbmp=LoadBmpFromFile(hWnd);
					if(tempbmp) {
						htempbmp=bmpSaveToHandle(hbmpdc,tempbmp);
						if(htempbmp) {
							hcurrentbmp=htempbmp;
							DeleteObject(SelectObject(hbmpdc,hcurrentbmp));
							bmpFree(currentbmp);
							currentbmp=tempbmp;
							if(hirabmp) {
								bmpFree(hirabmp);
								hirabmp=NULL;
							}
							wndresizebyclient(hWnd,
								getBmpWidth(currentbmp),
								getBmpHeight(currentbmp));
							SetMenuEnable(hWnd,FALSE);
							InvalidateRect(hWnd,NULL,FALSE);
						} else bmpFree(tempbmp);
					}
					break;
				case IDM_SAVE:
					SaveBmpToFile(hWnd,currentbmp);
					break;
				case IDM_END:
					SendMessage(hWnd,WM_CLOSE,0,0);
					break;
				case IDM_ENCRYPT:
					tempbmp=EncryptBmp(hWnd,currentbmp);
					if(tempbmp) {
						htempbmp=bmpSaveToHandle(hbmpdc,tempbmp);
						if(htempbmp) {
							hcurrentbmp=htempbmp;
							DeleteObject(SelectObject(hbmpdc,hcurrentbmp));
							bmpFree(currentbmp);
							if(hirabmp)bmpFree(hirabmp);
							hirabmp=currentbmp;
							currentbmp=tempbmp;
							SetMenuEnable(hWnd,TRUE);
							InvalidateRect(hWnd,NULL,FALSE);
						} else bmpFree(tempbmp);
					}
					break;
				case IDM_REENCRYPT:
					if(!hirabmp)break;
					tempbmp=EncryptBmp(hWnd,hirabmp);
					if(tempbmp) {
						htempbmp=bmpSaveToHandle(hbmpdc,tempbmp);
						if(htempbmp) {
							hcurrentbmp=htempbmp;
							DeleteObject(SelectObject(hbmpdc,hcurrentbmp));
							bmpFree(currentbmp);
							currentbmp=tempbmp;
							InvalidateRect(hWnd,NULL,FALSE);
						} else bmpFree(tempbmp);
					}
					break;
				case IDM_DECRYPT:
					tempbmp=DecryptBmp(hWnd,currentbmp);
					if(tempbmp) {
						htempbmp=bmpSaveToHandle(hbmpdc,tempbmp);
						if(htempbmp) {
							hcurrentbmp=htempbmp;
							DeleteObject(SelectObject(hbmpdc,hcurrentbmp));
							bmpFree(currentbmp);
							currentbmp=tempbmp;
							if(hirabmp) {
								bmpFree(hirabmp);
								hirabmp=NULL;
							}
							SetMenuEnable(hWnd,FALSE);
							InvalidateRect(hWnd,NULL,FALSE);
						} else bmpFree(tempbmp);
					}
					break;
				case IDM_HOWTOUSE:
					MessageBox(hWnd,
						"ut@Cvj[\r\n"
						"JFBMPt@CJ܂B\r\n"
						"ۑFBMPt@Cɕۑ܂B\r\n"
						"IFI܂B\r\n"
						"uÍvj[\r\n"
						"ÍF݂̉摜Í܂B\r\n"
						"ĈÍFÖÍ̑Ỏ摜Í܂B\r\n"
						"F݂̉摜𕜍܂B"
						,"g",MB_OK | MB_ICONINFORMATION);
					break;
				case IDM_VERSION:
					MessageBox(hWnd,"摜AES Ver1.00\r\nBy ݂CAT",
						"o[W",MB_OK | MB_ICONINFORMATION);
					break;
				default:
					return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			BitBlt(hdc,0,0,
				getBmpWidth(currentbmp),getBmpHeight(currentbmp),
				hbmpdc,0,0,SRCCOPY);
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			if(hirabmp)bmpFree(hirabmp);
			bmpFree(currentbmp);
			SelectObject(hbmpdc,holdbmp);
			DeleteObject(hcurrentbmp);
			DeleteDC(hbmpdc);
			if(password.password)HeapFree(GetProcessHeap(),0,password.password);
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   	}

	return 0;
}

int APIENTRY WinMain(HINSTANCE hInstance,
					 HINSTANCE hPrevInstance,
					 LPSTR	 lpCmdLine,
					 int	   nCmdShow)
{
	MSG msg;
	WNDCLASSEX wcex;
	HWND hWnd;

	hInst=hInstance;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style          = CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc    = (WNDPROC)WndProc;
	wcex.cbClsExtra     = 0;
	wcex.cbWndExtra     = 0;
	wcex.hInstance      = hInstance;
	wcex.hIcon          = LoadIcon(NULL,IDI_APPLICATION);
	wcex.hCursor        = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName   = "MAINMENU";
	wcex.lpszClassName  = szWindowClass;
	wcex.hIconSm        = NULL;

	RegisterClassEx(&wcex);

	hWnd = CreateWindow(szWindowClass,
		szWindowTitle, WS_OVERLAPPEDWINDOW &
		(~WS_THICKFRAME) & (~WS_MAXIMIZEBOX),
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
		NULL, NULL, hInstance, NULL);

	if (!hWnd) 
		return FALSE;

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}
